#***************************************************************************
#*   Copyright (C) 2006 by Andr Lindhjem <belgarat@sdf.lonestar.org>,     *
#*                         Kjetil Holien <kjetil.holien@gmail.com>,        *
#*                         Terje Risa <terje.risa@gmail.com> &             *
#*                         yvind Nerbrten <oyvind@nerbraaten.com>        *
#*                                                                         *
#*   This program is free software; you can redistribute it and/or modify  *
#*   it under the terms of the GNU General Public License as published by  *
#*   the Free Software Foundation; either version 2 of the License, or     *
#*   (at your option) any later version.                                   *
#*                                                                         *
#*   This program is distributed in the hope that it will be useful,       *
#*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
#*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
#*   GNU General Public License for more details.                          *
#*                                                                         *
#*   You should have received a copy of the GNU General Public License     *
#*   along with this program; if not, write to the                         *
#*   Free Software Foundation, Inc.,                                       *
#*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
#***************************************************************************

module DaisyXMLParser
	require "rexml/document"	
	
	class XMLParser
		@path = nil
		@number = 0
		@audioSource = nil
		@xmldoc = nil
		@@nccdoc = nil
		@lastsmil = nil
		@number = 0
		@smilFilesArray = nil
		@lastSmilFile = nil
		
		#initializes the class
		def initialize
			#the xml-file containing all the smil file paths
			puts "Give the full path to the ncc file of the book you want to play: (ncc.*)"
			source = gets.chop
			@path = source.slice(0..source.rindex('/'))
			puts "\nReading from " + source + "\n\n"
			nccfile = File.new(source)
			@nccdoc = REXML::Document.new nccfile
			@smilFilesArray = Array.new
			findSmilFiles
		end
		
		#parses the xml, at this point (03.02.2006) it only returns the next audiosource file
		#returns true if a new source is found
		#false otherwise
		def parseXML
			audioSourceFound = false
			#while there is still more smil-files to be parsed and no new audio file is found
			while findSmilFile  && !audioSourceFound do
				smilfile = File.new(@path+@lastSmilFile)
				smildoc = REXML::Document.new smilfile
				smildoc.elements.each("smil/body/seq/par") { |element|
					tmpaudiosource = element.elements["seq/audio"].attributes["src"]
					if tmpaudiosource == @audioSource
					else
						@audioSource = tmpaudiosource
						audioSourceFound = true
						return true	
					end
				}
			end
			return false
		end
		
		#finds the next smil-file
		#returns true if there is more smil-files
		def findSmilFile
			for i in 0..@smilFilesArray.size
				if !@lastSmilFile
					@lastSmilFile = @smilFilesArray[i]
					return true
				else
					if @smilFilesArray[i] == @lastSmilFile
						if i+1 < @smilFilesArray.size
							@lastSmilFile = @smilFilesArray[i+1]
							return true
						end
					end
				end
			end
			puts "\n\n\t Finished with the Daisybook, hope you had a wonderful time\n\n"
			return false
		end
		
		#finds all the smil-files in an array
		def findSmilFiles
			@nccdoc.elements.each("html/body/*/a") { |element| 
				tmpsmilsource = element.attributes["href"]
				if tmpsmilsource =~ /#/
					tmp = tmpsmilsource.chomp.split(/#/)
					tmpsmilsource = tmp[0]
					tmpsmilsourceanchor = tmp[1]
				end	
				@smilFilesArray.push(tmpsmilsource)
			}
		end
		
		#return the next audiosource
		#returns the filename if a source is found
		#	 false otherwise
		def getNextAudioSource
			if !parseXML
				return false
			else
				return @path+@audioSource
			end
		end
	end
end
